Index: /trunk/src/bp-groups/classes/class-bp-groups-group.php
===================================================================
--- /trunk/src/bp-groups/classes/class-bp-groups-group.php	(revision 10372)
+++ /trunk/src/bp-groups/classes/class-bp-groups-group.php	(revision 10373)
@@ -145,6 +145,6 @@
 	 * Constructor method.
 	 *
-	 * @param int|null $id Optional. If the ID of an existing group is provided,
-	 *                     the object will be pre-populated with info about that group.
+	 * @param int|null $id   Optional. If the ID of an existing group is provided,
+	 *                       the object will be pre-populated with info about that group.
 	 * @param array    $args {
 	 *     Array of optional arguments.
@@ -171,11 +171,11 @@
 		global $wpdb;
 
-		// Get BuddyPress
+		// Get BuddyPress.
 		$bp    = buddypress();
 
-		// Check cache for group data
+		// Check cache for group data.
 		$group = wp_cache_get( $this->id, 'bp_groups' );
 
-		// Cache missed, so query the DB
+		// Cache missed, so query the DB.
 		if ( false === $group ) {
 			$group = $wpdb->get_row( $wpdb->prepare( "SELECT g.* FROM {$bp->groups->table_name} g WHERE g.id = %d", $this->id ) );
@@ -184,5 +184,5 @@
 		}
 
-		// No group found so set the ID and bail
+		// No group found so set the ID and bail.
 		if ( empty( $group ) || is_wp_error( $group ) ) {
 			$this->id = 0;
@@ -190,5 +190,5 @@
 		}
 
-		// Group found so setup the object variables
+		// Group found so setup the object variables.
 		$this->id           = $group->id;
 		$this->creator_id   = $group->creator_id;
@@ -212,5 +212,5 @@
 			$admin_mods = $wpdb->get_results( apply_filters( 'bp_group_admin_mods_user_join_filter', $wpdb->prepare( "SELECT u.ID as user_id, u.user_login, u.user_email, u.user_nicename, m.is_admin, m.is_mod FROM {$wpdb->users} u, {$bp->groups->table_name_members} m WHERE u.ID = m.user_id AND m.group_id = %d AND ( m.is_admin = 1 OR m.is_mod = 1 )", $this->id ) ) );
 
-			// Add admins and moderators to their respective arrays
+			// Add admins and moderators to their respective arrays.
 			foreach ( (array) $admin_mods as $user ) {
 				if ( !empty( $user->is_admin ) ) {
@@ -222,9 +222,9 @@
 
 			// Set up some specific group vars from meta. Excluded
-			// from the bp_groups cache because it's cached independently
+			// from the bp_groups cache because it's cached independently.
 			$this->last_activity      = groups_get_groupmeta( $this->id, 'last_activity' );
 			$this->total_member_count = groups_get_groupmeta( $this->id, 'total_member_count' );
 
-			// Set user-specific data
+			// Set user-specific data.
 			$user_id          = bp_loggedin_user_id();
 			$this->is_member  = BP_Groups_Member::check_is_member( $user_id, $this->id );
@@ -235,8 +235,8 @@
 			if ( ( 'private' === $this->status ) || ( 'hidden' === $this->status ) ) {
 
-				// Assume user does not have access to hidden/private groups
+				// Assume user does not have access to hidden/private groups.
 				$this->user_has_access = false;
 
-				// Group members or community moderators have access
+				// Group members or community moderators have access.
 				if ( ( $this->is_member && is_user_logged_in() ) || bp_current_user_can( 'bp_moderate' ) ) {
 					$this->user_has_access = true;
@@ -277,20 +277,20 @@
 		do_action_ref_array( 'groups_group_before_save', array( &$this ) );
 
-		// Groups need at least a name
+		// Groups need at least a name.
 		if ( empty( $this->name ) ) {
 			return false;
 		}
 
-		// Set slug with group title if not passed
+		// Set slug with group title if not passed.
 		if ( empty( $this->slug ) ) {
 			$this->slug = sanitize_title( $this->name );
 		}
 
-		// Sanity check
+		// Sanity check.
 		if ( empty( $this->slug ) ) {
 			return false;
 		}
 
-		// Check for slug conflicts if creating new group
+		// Check for slug conflicts if creating new group.
 		if ( empty( $this->id ) ) {
 			$this->slug = groups_check_slug( $this->slug );
@@ -370,15 +370,15 @@
 		global $wpdb;
 
-		// Delete groupmeta for the group
+		// Delete groupmeta for the group.
 		groups_delete_groupmeta( $this->id );
 
-		// Fetch the user IDs of all the members of the group
+		// Fetch the user IDs of all the members of the group.
 		$user_ids    = BP_Groups_Member::get_group_member_ids( $this->id );
 		$user_id_str = esc_sql( implode( ',', wp_parse_id_list( $user_ids ) ) );
 
-		// Modify group count usermeta for members
+		// Modify group count usermeta for members.
 		$wpdb->query( "UPDATE {$wpdb->usermeta} SET meta_value = meta_value - 1 WHERE meta_key = 'total_group_count' AND user_id IN ( {$user_id_str} )" );
 
-		// Now delete all group member entries
+		// Now delete all group member entries.
 		BP_Groups_Member::delete_all( $this->id );
 
@@ -397,5 +397,5 @@
 		$bp = buddypress();
 
-		// Finally remove the group entry from the DB
+		// Finally remove the group entry from the DB.
 		if ( !$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name} WHERE id = %d", $this->id ) ) )
 			return false;
@@ -412,5 +412,4 @@
 	 * @param string|bool $table_name Optional. Name of the table to check
 	 *                                against. Default: $bp->groups->table_name.
-	 *
 	 * @return string|null ID of the group, if one is found, else null.
 	 */
@@ -433,5 +432,4 @@
 	 *
 	 * @param string $slug See {@link BP_Groups_Group::group_exists()}.
-	 *
 	 * @return string|null See {@link BP_Groups_Group::group_exists()}.
 	 */
@@ -445,5 +443,4 @@
 	 * @param int $user_id ID of the inviting user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return array IDs of users who have been invited to the group by the
 	 *               user but have not yet accepted.
@@ -515,5 +512,4 @@
 	 *        sort).
 	 * @param string|bool $order   ASC or DESC. Default: false (default sort).
-	 *
 	 * @return array {
 	 *     @type array $groups Array of matched and paginated group objects.
@@ -552,5 +548,4 @@
 	 *
 	 * @param string $slug Slug to check.
-	 *
 	 * @return string|null The slug, if found. Otherwise null.
 	 */
@@ -567,5 +562,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return string|null The slug, if found. Otherwise null.
 	 */
@@ -582,5 +576,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return bool True if the group has members, otherwise false.
 	 */
@@ -602,5 +595,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return int|null The number of outstanding requests, or null if
 	 *                  none are found.
@@ -649,5 +641,5 @@
 	 *      parameter format.
 	 *
-	 * @param array {
+	 * @param array $args {
 	 *     Array of parameters. All items are optional.
 	 *     @type string       $type              Optional. Shorthand for certain orderby/
@@ -692,5 +684,5 @@
 		global $wpdb;
 
-		// Backward compatibility with old method of passing arguments
+		// Backward compatibility with old method of passing arguments.
 		if ( ! is_array( $args ) || func_num_args() > 1 ) {
 			_deprecated_argument( __METHOD__, '1.7', sprintf( __( 'Arguments passed to %1$s should be in an associative array. See the inline documentation at %2$s for more details.', 'buddypress' ), __METHOD__, __FILE__ ) );
@@ -783,5 +775,5 @@
 		}
 
-		/** Order/orderby ********************************************/
+		/* Order/orderby ********************************************/
 
 		$order   = $r['order'];
@@ -789,5 +781,5 @@
 
 		// If a 'type' parameter was passed, parse it and overwrite
-		// 'order' and 'orderby' params passed to the function
+		// 'order' and 'orderby' params passed to the function.
 		if (  ! empty( $r['type'] ) ) {
 
@@ -804,5 +796,5 @@
 			// If an invalid type is passed, $order_orderby will be
 			// an array with empty values. In this case, we stick
-			// with the default values of $order and $orderby
+			// with the default values of $order and $orderby.
 			if ( ! empty( $order_orderby['order'] ) ) {
 				$order = $order_orderby['order'];
@@ -814,5 +806,5 @@
 		}
 
-		// Sanitize 'order'
+		// Sanitize 'order'.
 		$order = bp_esc_sql_order( $order );
 
@@ -828,5 +820,5 @@
 		$orderby = apply_filters( 'bp_groups_get_orderby_converted_by_term', self::convert_orderby_to_order_by_term( $orderby ), $orderby, $r['type'] );
 
-		// Random order is a special case
+		// Random order is a special case.
 		if ( 'rand()' === $orderby ) {
 			$sql[] = "ORDER BY rand()";
@@ -870,20 +862,20 @@
 
 		// Temporary implementation of meta_query for total count
-		// See #5099
+		// See #5099.
 		if ( ! empty( $meta_query_sql['where'] ) ) {
-			// Join the groupmeta table
+			// Join the groupmeta table.
 			$total_sql['select'] .= ", ". substr( $meta_query_sql['join'], 0, -2 );
 
-			// Modify the meta_query clause from paged_sql for our syntax
+			// Modify the meta_query clause from paged_sql for our syntax.
 			$meta_query_clause = preg_replace( '/^\s*AND/', '', $meta_query_sql['where'] );
 			$total_sql['where'][] = $meta_query_clause;
 		}
 
-		// Already escaped in the paginated results block
+		// Already escaped in the paginated results block.
 		if ( ! empty( $include ) ) {
 			$total_sql['where'][] = "g.id IN ({$include})";
 		}
 
-		// Already escaped in the paginated results block
+		// Already escaped in the paginated results block.
 		if ( ! empty( $exclude ) ) {
 			$total_sql['where'][] = "g.id NOT IN ({$exclude})";
@@ -916,10 +908,10 @@
 		}
 
-		// Populate some extra information instead of querying each time in the loop
+		// Populate some extra information instead of querying each time in the loop.
 		if ( !empty( $r['populate_extras'] ) ) {
 			$paged_groups = BP_Groups_Group::get_group_extras( $paged_groups, $group_ids, $r['type'] );
 		}
 
-		// Grab all groupmeta
+		// Grab all groupmeta.
 		if ( ! empty( $r['update_meta_cache'] ) ) {
 			bp_groups_update_meta_cache( $group_ids );
@@ -944,5 +936,4 @@
 	 * @param array $meta_query An array of meta_query filters. See the
 	 *                          documentation for {@link WP_Meta_Query} for details.
-	 *
 	 * @return array $sql_array 'join' and 'where' clauses.
 	 */
@@ -959,5 +950,5 @@
 
 			// WP_Meta_Query expects the table name at
-			// $wpdb->group
+			// $wpdb->group.
 			$wpdb->groupmeta = buddypress()->groups->table_name_groupmeta;
 
@@ -971,5 +962,5 @@
 			// @todo It may be better in the long run to refactor
 			// the more general query syntax to accord better with
-			// BP/WP convention
+			// BP/WP convention.
 			preg_match_all( '/JOIN (.+?) ON/', $meta_sql['join'], $matches_a );
 			preg_match_all( '/ON \((.+?)\)/', $meta_sql['join'], $matches_b );
@@ -992,6 +983,6 @@
 	 *
 	 * @return array {
-	 *	@type string $order   SQL-friendly order string.
-	 *	@type string $orderby SQL-friendly orderby column name.
+	 *     @type string $order   SQL-friendly order string.
+	 *     @type string $orderby SQL-friendly orderby column name.
 	 * }
 	 */
@@ -1044,5 +1035,4 @@
 	 * @param string|array|bool $exclude         Optional. Array or comma-separated list of group
 	 *                                           IDs to exclude from results.
-	 *
 	 * @return array {
 	 *     @type array $groups Array of group objects returned by the
@@ -1105,5 +1095,4 @@
 	 *
 	 * @param string $orderby Orderby term as passed to get().
-	 *
 	 * @return string $order_by_term SQL-friendly orderby term.
 	 */
@@ -1150,5 +1139,4 @@
 	 * @param string|array|bool $exclude         Optional. Array or comma-separated list of group
 	 *                                           IDs to exclude from results.
-	 *
 	 * @return array {
 	 *     @type array $groups Array of group objects returned by the
@@ -1229,5 +1217,5 @@
 		$pag_sql = $hidden_sql = $exclude_sql = '';
 
-		// Multibyte compliance
+		// Multibyte compliance.
 		if ( function_exists( 'mb_strlen' ) ) {
 			if ( mb_strlen( $letter, 'UTF-8' ) > 1 || is_numeric( $letter ) || !$letter ) {
@@ -1287,5 +1275,4 @@
 	 * @param string|array|bool $exclude         Optional. Array or comma-separated list of group
 	 *                                           IDs to exclude from results.
-	 *
 	 * @return array {
 	 *     @type array $groups Array of group objects returned by the
@@ -1345,5 +1332,4 @@
 	 *
 	 * Data fetched:
-	 *
 	 *     - Logged-in user's status within each group (is_member,
 	 *       is_confirmed, is_pending, is_banned)
@@ -1353,5 +1339,4 @@
 	 *                                   $paged_groups.
 	 * @param string|bool  $type         Not used.
-	 *
 	 * @return array $paged_groups
 	 */
@@ -1364,8 +1349,8 @@
 		$bp = buddypress();
 
-		// Sanitize group IDs
+		// Sanitize group IDs.
 		$group_ids = implode( ',', wp_parse_id_list( $group_ids ) );
 
-		// Fetch the logged-in user's status within each group
+		// Fetch the logged-in user's status within each group.
 		if ( is_user_logged_in() ) {
 			$user_status_results = $wpdb->get_results( $wpdb->prepare( "SELECT group_id, is_confirmed, invite_sent FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id IN ( {$group_ids} ) AND is_banned = 0", bp_loggedin_user_id() ) );
@@ -1374,5 +1359,5 @@
 		}
 
-		// Reindex
+		// Reindex.
 		$user_status = array();
 		foreach ( $user_status_results as $user_status_result ) {
@@ -1386,13 +1371,13 @@
 			if ( isset( $user_status[ $gid ] ) ) {
 
-				// is_confirmed means the user is a member
+				// The is_confirmed means the user is a member.
 				if ( $user_status[ $gid ]->is_confirmed ) {
 					$is_member = '1';
 
-				// invite_sent means the user has been invited
+				// The invite_sent means the user has been invited.
 				} elseif ( $user_status[ $gid ]->invite_sent ) {
 					$is_invited = '1';
 
-				// User has sent request, but has not been confirmed
+				// User has sent request, but has not been confirmed.
 				} else {
 					$is_pending = '1';
@@ -1428,5 +1413,4 @@
 	 *
 	 * @param int $group_id ID of the group whose invitations are being deleted.
-	 *
 	 * @return int|null Number of rows records deleted on success, null on
 	 *                  failure.
@@ -1465,5 +1449,4 @@
 	 * @param string $type Optional. If 'unreplied', count will be limited to
 	 *                     those topics that have received no replies.
-	 *
 	 * @return int Forum topic count.
 	 */
@@ -1479,5 +1462,5 @@
 		 * Filters the portion of the SQL related to global count of forum topics in public groups.
 		 *
-		 * https://buddypress.trac.wordpress.org/ticket/4306.
+		 * See https://buddypress.trac.wordpress.org/ticket/4306.
 		 *
 		 * @since 1.6.0
@@ -1488,5 +1471,5 @@
 		$extra_sql = apply_filters( 'get_global_forum_topic_count_extra_sql', $bp->groups->filter_sql, $type );
 
-		// Make sure the $extra_sql begins with an AND
+		// Make sure the $extra_sql begins with an AND.
 		if ( 'AND' != substr( trim( strtoupper( $extra_sql ) ), 0, 3 ) )
 			$extra_sql = ' AND ' . $extra_sql;
@@ -1499,5 +1482,4 @@
 	 *
 	 * @param int $group_id Group ID.
-	 *
 	 * @return int Count of confirmed members for the group.
 	 */
@@ -1518,5 +1500,4 @@
 	 *                                  'hidden', or 'all'. Default: 'public'.
 	 * @param string|bool $search_terms Provided search terms.
-	 *
 	 * @return int The topic count
 	 */
Index: /trunk/src/bp-groups/classes/class-bp-groups-member-suggestions.php
===================================================================
--- /trunk/src/bp-groups/classes/class-bp-groups-member-suggestions.php	(revision 10372)
+++ /trunk/src/bp-groups/classes/class-bp-groups-member-suggestions.php	(revision 10373)
@@ -94,5 +94,5 @@
 	public function get_suggestions() {
 		$user_query = array(
-			'count_total'     => '',  // Prevents total count
+			'count_total'     => '',  // Prevents total count.
 			'populate_extras' => false,
 			'type'            => 'alphabetical',
@@ -117,5 +117,5 @@
 		} else {
 			$group_query = array(
-				'count_total'     => '',  // Prevents total count
+				'count_total'     => '',  // Prevents total count.
 				'populate_extras' => false,
 				'type'            => 'alphabetical',
Index: /trunk/src/bp-groups/classes/class-bp-groups-member.php
===================================================================
--- /trunk/src/bp-groups/classes/class-bp-groups-member.php	(revision 10372)
+++ /trunk/src/bp-groups/classes/class-bp-groups-member.php	(revision 10373)
@@ -131,5 +131,5 @@
 	public function __construct( $user_id = 0, $group_id = 0, $id = false, $populate = true ) {
 
-		// User and group are not empty, and ID is
+		// User and group are not empty, and ID is.
 		if ( !empty( $user_id ) && !empty( $group_id ) && empty( $id ) ) {
 			$this->user_id  = $user_id;
@@ -141,5 +141,5 @@
 		}
 
-		// ID is not empty
+		// ID is not empty.
 		if ( !empty( $id ) ) {
 			$this->id = $id;
@@ -226,5 +226,5 @@
 			$sql = $wpdb->prepare( "UPDATE {$bp->groups->table_name_members} SET inviter_id = %d, is_admin = %d, is_mod = %d, is_banned = %d, user_title = %s, date_modified = %s, is_confirmed = %d, comments = %s, invite_sent = %d WHERE id = %d", $this->inviter_id, $this->is_admin, $this->is_mod, $this->is_banned, $this->user_title, $this->date_modified, $this->is_confirmed, $this->comments, $this->invite_sent, $this->id );
 		} else {
-			// Ensure that user is not already a member of the group before inserting
+			// Ensure that user is not already a member of the group before inserting.
 			if ( $wpdb->get_var( $wpdb->prepare( "SELECT id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_confirmed = 1 LIMIT 1", $this->user_id, $this->group_id ) ) ) {
 				return false;
@@ -239,8 +239,8 @@
 		$this->id = $wpdb->insert_id;
 
-		// Update the user's group count
+		// Update the user's group count.
 		self::refresh_total_group_count_for_user( $this->user_id );
 
-		// Update the group's member count
+		// Update the group's member count.
 		self::refresh_total_member_count_for_group( $this->group_id );
 
@@ -263,5 +263,4 @@
 	 *
 	 * @param string $status The new status. 'mod' or 'admin'.
-	 *
 	 * @return bool True on success, false on failure.
 	 */
@@ -364,8 +363,8 @@
 			return false;
 
-		// Update the user's group count
+		// Update the user's group count.
 		self::refresh_total_group_count_for_user( $this->user_id );
 
-		// Update the group's member count
+		// Update the group's member count.
 		self::refresh_total_member_count_for_group( $this->group_id );
 
@@ -390,5 +389,4 @@
 	 *
 	 * @param int $user_id ID of the user.
-	 *
 	 * @return bool True on success, false on failure.
 	 */
@@ -403,5 +401,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return bool True on success, false on failure.
 	 */
@@ -415,5 +412,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return True on success, false on failure.
 	 */
@@ -434,8 +430,8 @@
 		$remove = $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d", $user_id, $group_id ) );
 
-		// Update the user's group count
+		// Update the user's group count.
 		self::refresh_total_group_count_for_user( $user_id );
 
-		// Update the group's member count
+		// Update the group's member count.
 		self::refresh_total_member_count_for_group( $group_id );
 
@@ -475,5 +471,5 @@
 		$bp = buddypress();
 
-		// If the user is logged in and viewing their own groups, we can show hidden and private groups
+		// If the user is logged in and viewing their own groups, we can show hidden and private groups.
 		if ( $user_id != bp_loggedin_user_id() ) {
 			$group_sql = $wpdb->prepare( "SELECT DISTINCT m.group_id FROM {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.status != 'hidden' AND m.user_id = %d AND m.is_confirmed = 1 AND m.is_banned = 0{$pag_sql}", $user_id );
@@ -540,5 +536,4 @@
 	 * @param string|bool $filter  Optional. Limit results to groups whose name or
 	 *                             description field matches search terms.
-	 *
 	 * @return array {
 	 *     @type array $groups Array of groups returned by paginated query.
@@ -574,48 +569,4 @@
 	/**
 	 * Get the IDs of the groups of which a specified user is a moderator.
-	 *
-	 * @param int         $user_id ID of the user.
-	 * @param int|bool    $limit   Optional. Max number of results to return.
-	 *                             Default: false (no limit).
-	 * @param int|bool    $page    Optional. Page offset of results to return.
-	 *                             Default: false (no limit).
-	 * @param string|bool $filter  Optional. Limit results to groups whose name or
-	 *                             description field matches search terms.
-	 *
-	 * @return array {
-	 *     @type array $groups Array of groups returned by paginated query.
-	 *     @type int   $total  Count of groups matching query.
-	 * }
-	 */
-	public static function get_is_mod_of( $user_id, $limit = false, $page = false, $filter = false ) {
-		global $wpdb;
-
-		$user_id_sql = $pag_sql = $hidden_sql = $filter_sql = '';
-
-		$user_id_sql = $wpdb->prepare( 'm.user_id = %d', $user_id );
-
-		if ( !empty( $limit ) && !empty( $page ) )
-			$pag_sql = $wpdb->prepare( " LIMIT %d, %d", intval( ( $page - 1 ) * $limit), intval( $limit ) );
-
-		if ( !empty( $filter ) ) {
-			$search_terms_like = '%' . bp_esc_like( $filter ) . '%';
-			$filter_sql = $wpdb->prepare( " AND ( g.name LIKE %s OR g.description LIKE %s )", $search_terms_like, $search_terms_like );
-		}
-
-		if ( $user_id != bp_loggedin_user_id() )
-			$hidden_sql = " AND g.status != 'hidden'";
-
-		$bp = buddypress();
-
-		$paged_groups = $wpdb->get_results( "SELECT g.*, gm1.meta_value as total_member_count, gm2.meta_value as last_activity FROM {$bp->groups->table_name_groupmeta} gm1, {$bp->groups->table_name_groupmeta} gm2, {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.id = m.group_id AND g.id = gm1.group_id AND g.id = gm2.group_id AND gm2.meta_key = 'last_activity' AND gm1.meta_key = 'total_member_count'{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_mod = 1 ORDER BY m.date_modified ASC {$pag_sql}" );
-		$total_groups = $wpdb->get_var( "SELECT COUNT(DISTINCT m.group_id) FROM {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE m.group_id = g.id{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_mod = 1 ORDER BY date_modified ASC" );
-
-		return array( 'groups' => $paged_groups, 'total' => $total_groups );
-	}
-
-	/**
-	 * Get the groups of which a specified user is banned from.
-	 *
-	 * @since 2.4
 	 *
 	 * @param int         $user_id ID of the user.
@@ -631,4 +582,47 @@
 	 * }
 	 */
+	public static function get_is_mod_of( $user_id, $limit = false, $page = false, $filter = false ) {
+		global $wpdb;
+
+		$user_id_sql = $pag_sql = $hidden_sql = $filter_sql = '';
+
+		$user_id_sql = $wpdb->prepare( 'm.user_id = %d', $user_id );
+
+		if ( !empty( $limit ) && !empty( $page ) )
+			$pag_sql = $wpdb->prepare( " LIMIT %d, %d", intval( ( $page - 1 ) * $limit), intval( $limit ) );
+
+		if ( !empty( $filter ) ) {
+			$search_terms_like = '%' . bp_esc_like( $filter ) . '%';
+			$filter_sql = $wpdb->prepare( " AND ( g.name LIKE %s OR g.description LIKE %s )", $search_terms_like, $search_terms_like );
+		}
+
+		if ( $user_id != bp_loggedin_user_id() )
+			$hidden_sql = " AND g.status != 'hidden'";
+
+		$bp = buddypress();
+
+		$paged_groups = $wpdb->get_results( "SELECT g.*, gm1.meta_value as total_member_count, gm2.meta_value as last_activity FROM {$bp->groups->table_name_groupmeta} gm1, {$bp->groups->table_name_groupmeta} gm2, {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.id = m.group_id AND g.id = gm1.group_id AND g.id = gm2.group_id AND gm2.meta_key = 'last_activity' AND gm1.meta_key = 'total_member_count'{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_mod = 1 ORDER BY m.date_modified ASC {$pag_sql}" );
+		$total_groups = $wpdb->get_var( "SELECT COUNT(DISTINCT m.group_id) FROM {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE m.group_id = g.id{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_mod = 1 ORDER BY date_modified ASC" );
+
+		return array( 'groups' => $paged_groups, 'total' => $total_groups );
+	}
+
+	/**
+	 * Get the groups of which a specified user is banned from.
+	 *
+	 * @since 2.4
+	 *
+	 * @param int         $user_id ID of the user.
+	 * @param int|bool    $limit   Optional. Max number of results to return.
+	 *                             Default: false (no limit).
+	 * @param int|bool    $page    Optional. Page offset of results to return.
+	 *                             Default: false (no limit).
+	 * @param string|bool $filter  Optional. Limit results to groups whose name or
+	 *                             description field matches search terms.
+	 * @return array {
+	 *     @type array $groups Array of groups returned by paginated query.
+	 *     @type int   $total  Count of groups matching query.
+	 * }
+	 */
 	public static function get_is_banned_of( $user_id, $limit = false, $page = false, $filter = false ) {
 		global $wpdb;
@@ -662,5 +656,4 @@
 	 *
 	 * @param int $user_id Optional. Default: ID of the displayed user.
-	 *
 	 * @return int Group count.
 	 */
@@ -690,5 +683,4 @@
 	 * @param string|array|bool $exclude Optional. Array or comma-separated list
 	 *                                   of group IDs to exclude from results.
-	 *
 	 * @return array {
 	 *     @type array $groups Array of groups returned by paginated query.
@@ -721,5 +713,4 @@
 	 *
 	 * @param int $user_id The user ID.
-	 *
 	 * @return int
 	 */
@@ -746,5 +737,4 @@
 	 * @param string $type     If 'sent', results are limited to those invitations
 	 *                         that have actually been sent (non-draft). Default: 'sent'.
-	 *
 	 * @return int|null The ID of the invitation if found, otherwise null.
 	 */
@@ -771,5 +761,4 @@
 	 * @param  int $user_id  ID of the user.
 	 * @param  int $group_id ID of the group.
-	 *
 	 * @return int Number of records deleted.
 	 */
@@ -799,5 +788,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return int Number of records deleted.
 	 */
@@ -818,5 +806,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return mixed
 	 */
@@ -837,5 +824,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return mixed
 	 */
@@ -856,5 +842,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return mixed
 	 */
@@ -875,5 +860,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return mixed
 	 */
@@ -896,5 +880,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return int|null ID of the group if the user is the creator,
 	 *                  otherwise false.
@@ -916,5 +899,4 @@
 	 * @param int $user_id  ID of the user.
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return int|null ID of the membership if found, otherwise false.
 	 */
@@ -935,5 +917,4 @@
 	 * @param int $user_id      ID of the user.
 	 * @param int $total_groups Max number of group IDs to return. Default: 5.
-	 *
 	 * @return array Group IDs.
 	 */
@@ -943,5 +924,5 @@
 		$bp = buddypress();
 
-		// If the user is logged in and viewing their random groups, we can show hidden and private groups
+		// If the user is logged in and viewing their random groups, we can show hidden and private groups.
 		if ( bp_is_my_profile() ) {
 			return $wpdb->get_col( $wpdb->prepare( "SELECT DISTINCT group_id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND is_confirmed = 1 AND is_banned = 0 ORDER BY rand() LIMIT %d", $user_id, $total_groups ) );
@@ -955,5 +936,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return array IDs of all group members.
 	 */
@@ -970,5 +950,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return array Info about group admins (user_id + date_modified).
 	 */
@@ -992,5 +971,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return array Info about group mods (user_id + date_modified).
 	 */
@@ -1007,5 +985,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return array IDs of users with outstanding membership requests.
 	 */
@@ -1023,11 +1000,10 @@
 	 * @deprecated 1.8.0
 	 *
-	 * @param $group_id
-	 * @param $limit
-	 * @param $page
-	 * @param $exclude_admins_mods
-	 * @param $exclude_banned
-	 * @param $exclude
-	 *
+	 * @param int        $group_id            ID of the group being queried for.
+	 * @param bool/int   $limit               Max amount to return.
+	 * @param bool/int   $page                Pagination value.
+	 * @param bool       $exclude_admins_mods Whether or not to exclude admins and moderators.
+	 * @param bool       $exclude_banned      Whether or not to exclude banned members.
+	 * @param bool/array $exclude             Array of user IDs to exclude.
 	 * @return mixed
 	 */
@@ -1091,5 +1067,5 @@
 		}
 
-		// Fetch whether or not the user is a friend
+		// Fetch whether or not the user is a friend.
 		foreach ( (array) $members as $user )
 			$user_ids[] = $user->user_id;
@@ -1115,5 +1091,4 @@
 	 *
 	 * @param int $group_id ID of the group.
-	 *
 	 * @return int Number of records deleted.
 	 */
@@ -1132,5 +1107,4 @@
 	 *
 	 * @param int $user_id ID of the user.
-	 *
 	 * @return mixed
 	 */
@@ -1140,10 +1114,10 @@
 		$bp = buddypress();
 
-		// Get all the group ids for the current user's groups and update counts
+		// Get all the group ids for the current user's groups and update counts.
 		$group_ids = BP_Groups_Member::get_group_ids( $user_id );
 		foreach ( $group_ids['groups'] as $group_id ) {
 			groups_update_groupmeta( $group_id, 'total_member_count', groups_get_total_member_count( $group_id ) - 1 );
 
-			// If current user is the creator of a group and is the sole admin, delete that group to avoid counts going out-of-sync
+			// If current user is the creator of a group and is the sole admin, delete that group to avoid counts going out-of-sync.
 			if ( groups_is_user_admin( $user_id, $group_id ) && count( groups_get_group_admins( $group_id ) ) < 2 && groups_is_user_creator( $user_id, $group_id ) )
 				groups_delete_group( $group_id );
